using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Runtime.Serialization;

using Syncfusion.Drawing;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms;

namespace MyGridSample
{
	class ComboBoxCellModel : GridComboBoxCellModel
	{
		protected ComboBoxCellModel(SerializationInfo info, StreamingContext context)
			: base(info, context)
		{
		}

		public ComboBoxCellModel(GridModel grid)
			: base(grid)
		{
			AllowFloating = false;
		}
	
		public override GridCellRendererBase CreateRenderer(GridControlBase control)
		{
			return new ComboBoxCellRenderer(control, this);
		}
	}

	public class ComboBoxCellRenderer: GridComboBoxCellRenderer
	{
		public ComboBoxCellRenderer(GridControlBase grid, GridCellModelBase cellModel)
			: base(grid, cellModel)
		{

		}
	
		protected override void OnEditPartMouseDown(object sender, MouseEventArgs e)
		{
			// Don't swtich for read-only cells...
			if(StyleInfo.ReadOnly)
			{
				return;
			}
			else
				base.OnEditPartMouseDown(sender, e);
		}
	}
}
