using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Tools;
using Syncfusion.Windows.Forms.Grid;

namespace MyGridSample
{
	/// <summary>
	/// Zusammenfassung fr Form1.
	/// </summary>
	public class MyForm : System.Windows.Forms.Form
	{
        private MyDataSet m_ds = new MyDataSet();
        private Syncfusion.Windows.Forms.Grid.GridBoundColumn m_gcolDescription;
        private Syncfusion.Windows.Forms.Grid.GridBoundColumn m_gcolType;
        private Syncfusion.Windows.Forms.Grid.GridBoundColumn m_gcolMainID;
        private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid m_gridMain;
		/// <summary>
		/// Erforderliche Designervariable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public MyForm()
		{
			InitializeComponent();

            InitializeDataSet();

            InitializeControls();
        }


        private void InitializeDataSet()
        {
            // DataTable "MainTable"
            MyDataSet.MainTableRow dr = (MyDataSet.MainTableRow)(m_ds.MainTable.NewRow());
            dr.BeginEdit();
            dr.Description = "First description";
            dr.Type_ID = -1;
            dr.EndEdit();
            m_ds.MainTable.Rows.Add( dr );

            dr = (MyDataSet.MainTableRow)(m_ds.MainTable.NewRow());
            dr.BeginEdit();
            dr.Description = "Second description";
            dr.Type_ID = -2;
            dr.EndEdit();
            m_ds.MainTable.Rows.Add( dr );

            dr = (MyDataSet.MainTableRow)(m_ds.MainTable.NewRow());
            dr.BeginEdit();
            dr.Description = "Third description";
            dr.Type_ID = -1;
            dr.EndEdit();
            m_ds.MainTable.Rows.Add( dr );

            // DataTable "TypeTable"
            m_ds.TypeTable.AddTypeTableRow( "First type" );
            m_ds.TypeTable.AddTypeTableRow( "Second type" );
        }


        private void InitializeControls()
        {
			// Adds the derived combo the grid's cell collection
			m_gridMain.Model.CellModels.Add("Combo", new ComboBoxCellModel(this.m_gridMain.Model));

            // Init grid
            DataView dv = new DataView( m_ds.MainTable );

            m_gridMain.DataSource = dv;
			m_gcolType.StyleInfo.CellType = "Combo";
            m_gcolType.StyleInfo.DisplayMember  = "Description";
            m_gcolType.StyleInfo.ValueMember    = "Type_ID";
            m_gcolType.StyleInfo.DataSource     = m_ds.TypeTable.DefaultView;

            m_gridMain.AllowResizeToFit = false;
            m_gridMain.SetColWidth( 1, 1, 60 );
            m_gridMain.SetColWidth( 2, 3, 150 );
        }


		/// <summary>
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Windows Form-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			Syncfusion.Windows.Forms.Grid.GridStyleInfo gridStyleInfo1 = new Syncfusion.Windows.Forms.Grid.GridStyleInfo();
			this.m_gridMain = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			this.m_gcolMainID = new Syncfusion.Windows.Forms.Grid.GridBoundColumn();
			this.m_gcolDescription = new Syncfusion.Windows.Forms.Grid.GridBoundColumn();
			this.m_gcolType = new Syncfusion.Windows.Forms.Grid.GridBoundColumn();
			((System.ComponentModel.ISupportInitialize)(this.m_gridMain)).BeginInit();
			this.SuspendLayout();
			// 
			// m_gridMain
			// 
			this.m_gridMain.AllowDragSelectedCols = true;
			this.m_gridMain.EnableAddNew = false;
			this.m_gridMain.EnableEdit = false;
			this.m_gridMain.EnableRemove = false;
			this.m_gridMain.GridBoundColumns.AddRange(new Syncfusion.Windows.Forms.Grid.GridBoundColumn[] {
																											  this.m_gcolMainID,
																											  this.m_gcolDescription,
																											  this.m_gcolType});
			this.m_gridMain.Location = new System.Drawing.Point(8, 8);
			this.m_gridMain.Name = "m_gridMain";
			this.m_gridMain.OptimizeInsertRemoveCells = true;
			this.m_gridMain.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.m_gridMain.Size = new System.Drawing.Size(552, 232);
			this.m_gridMain.SmartSizeBox = false;
			this.m_gridMain.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.m_gridMain.TabIndex = 0;
			gridStyleInfo1.ReadOnly = true;
			this.m_gridMain.TableStyle = gridStyleInfo1;
			this.m_gridMain.Text = "gridDataBoundGrid1";
			this.m_gridMain.UseListChangedEvent = true;
			// 
			// m_gcolMainID
			// 
			this.m_gcolMainID.HeaderText = "Main ID";
			this.m_gcolMainID.MappingName = "Main_ID";
			this.m_gcolMainID.ReadOnly = true;
			this.m_gcolMainID.StyleInfo.CellType = "Static";
			this.m_gcolMainID.StyleInfo.ReadOnly = false;
			// 
			// m_gcolDescription
			// 
			this.m_gcolDescription.HeaderText = "Description";
			this.m_gcolDescription.MappingName = "Description";
			this.m_gcolDescription.StyleInfo.CellType = "Static";
			// 
			// m_gcolType
			// 
			this.m_gcolType.HeaderText = "Type";
			this.m_gcolType.MappingName = "Type_ID";
			this.m_gcolType.StyleInfo.CellType = "ComboBox";
			this.m_gcolType.StyleInfo.CellValueType = typeof(int);
			this.m_gcolType.StyleInfo.DropDownStyle = Syncfusion.Windows.Forms.Grid.GridDropDownStyle.Editable;
			this.m_gcolType.StyleInfo.ShowButtons = Syncfusion.Windows.Forms.Grid.GridShowButtons.Hide;
			// 
			// MyForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(624, 245);
			this.Controls.Add(this.m_gridMain);
			this.Name = "MyForm";
			this.Text = "MyForm";
			((System.ComponentModel.ISupportInitialize)(this.m_gridMain)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Der Haupteinstiegspunkt fr die Anwendung.
		/// </summary>
		[STAThread]
		static void Main() 
		{
            try
            {
                Application.Run( new MyForm() );
            }
            catch( System.Exception ex )
            {
                MessageBox.Show( ex.ToString() );
            }
		}
	}
}
